# $Id$
# Authority: lsn
# Upstream:

%define myname		LandShark BuildSys
%define myemail		<BuildSys[AT]LandShark.Net>
%define distro		CentOS 4

Name		: postgrey
Summary		: Postfix Greylisting Policy Server
Version		: 1.27
Release		: 1.el4.lsn

License		: GPL
Group		: System Environment/Daemons

URL		: http://isg.ee.ethz.ch/tools/postgrey/
Vendor		: LandShark Networks
Distribution	: %distro
Packager	: %{myname} %{myemail}

BuildRoot	: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
Source0		: http://isg.ee.ethz.ch/tools/postgrey/pub/%{name}-%{version}.tar.gz

patch0		: postgrey-group.patch

Buildarch	: noarch

Prereq		: perl, perl-IO-Multiplex, perl-Net-Server, perl-BerkeleyDB, db4 >= 4.1

%define confdir 	/etc/postfix
%define uid 95
%define gid 95

%description
Postgrey is a Postfix policy server implementing greylisting.
When a request for delivery of a mail is received by Postfix 
via SMTP, the triplet CLIENT_IP / SENDER / RECIPIENT is built. 
If it is the first time that this triplet is seen, or if the 
triplet was first seen less than 5 minutes, then the mail gets 
rejected with a temporary error. Hopefully spammers or viruses 
will not try again later, as it is however required per RFC.
Edit your configuration files:
/etc/postfix/main.cf:
  smtpd_recipient_restrictions = ...
    check_policy_service unix:postgrey/socket, ...
or if you like to use inet sockets (modify the IP if needed):
/etc/sysconfig/postgrey:
  OPTIONS="--inet=127.0.0.1:10023"
/etc/postfix/main.cf:
  smtpd_recipient_restrictions = ...
    check_policy_service inet:127.0.0.1:10023, ...


%prep
%setup -q -n %{name}-%{version}
%patch0 -p1

%build

%install
%{__rm} -rf %{buildroot}

%{__install} -d -m0755 %{buildroot}%{_initrddir}
%{__install} -m0755 %{SOURCE0} %{buildroot}%{_initrddir}/%{name}

%{__install} -d -m0755 %{buildroot}%{_sysconfdir}/postfix
%{__install} -m0644 postgrey_whitelist_clients %{buildroot}%{_sysconfdir}/postfix
%{__install} -m0644 postgrey_whitelist_recipients %{buildroot}%{_sysconfdir}/postfix
touch %{buildroot}%{_sysconfdir}/postfix/postgrey_whitelist_clients.local

%{__install} -d -m0755 %{buildroot}%{_sbindir}
%{__install} -m0755 postgrey %{buildroot}%{_sbindir}
%{__install} -m0755 contrib/postgreyreport %{buildroot}%{_sbindir}

%{__install} -d -m0711 %{buildroot}%{_var}/spool/postfix/%{name}

%clean
%{__rm} -rf %{buildroot}

%pre
if [ $1 -eq 1 ]; then
	# if %{gid} is already taken, let's create the group with another low gid, chosen by groupadd
	if { getent group | egrep -q "^[^:]+:[^:]*:%{gid}:" ; } ; then
		GIDOPT=""
	else
		GIDOPT="-g %{gid}"
	fi
	# the same for the uid
	if { getent passwd | egrep -q "^[^:]+:[^:]*:%{uid}:" ; } ; then
		UIDOPT=""
	else
		UIDOPT="-u %{uid}"
	fi
	%{_sbindir}/groupadd $GIDOPT -r %{name} &>/dev/null || :
	%{_sbindir}/useradd -d %{_var}/spool/postfix/%{name} -s /sbin/nologin $UIDOPT -g postgrey -M -r %{name} 2>/dev/null || :
fi

%post
/sbin/chkconfig --add %{name}

%preun
if [ $1 -eq 0 ]; then
        /sbin/service %{name} stop &>/dev/null || :
        /sbin/chkconfig --del %{name}
fi

%postun
if [ $1 -eq 0 ]; then
	%{_sbindir}/userdel %{name} 2>/dev/null || :
	%{_sbindir}/groupdel %{name} 2>/dev/null || :
	%{__rm} -rf %{_var}/spool/postfix/%{name}
fi


%files
%defattr(-,root,root)
%doc README Changes COPYING
%{_initrddir}/%{name}
%config(noreplace) %{confdir}/postgrey_whitelist_clients
%config(noreplace) %{confdir}/postgrey_whitelist_recipients
%config(noreplace) %{confdir}/postgrey_whitelist_clients.local
%{_sbindir}/postgrey*
%dir %attr(0711, postgrey, postgrey) %{_var}/spool/postfix/%{name}

%changelog
* Thu Jul 27 2006 LandShark BuildSys <BuildSys[AT]LandShark.Net>
- fix socket permissions with Net::Server >= 0.94 (Leos Bitto)

* Sun May 07 2006 LandShark BuildSys <BuildSys[AT]LandShark.Net>
- Updated to version 1.24

* Sat Jan 14 2006 LandShark BuildSys <BuildSys[AT]LandShark.Net>
- Initial CentOS 4 build.
